/* Problem URL: https://codeforces.com/problemset/problem/2048/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;

    vl a(n);
    vl b(m);
    cin >> a >> b;

    int ke = a[0];
    sort(all(a), greater<>());

    while (!a.empty() && a.back() <= ke) {
        a.pop_back();
    }

    if (a.empty()) {
        nrep(i, 1, m + 1) {
            cout << (m / i) << " \n"[i == m];
        }
        return;
    }

    sortv(b);

    vl act;
    int i = 0;
    while (i < m && b[i] <= ke) {
        act.push_back(b[i]);
        i++;
    }

    int lim = i;

    i = m - 1;
    while (i >= 0 && b[i] > ke) {
        act.push_back(b[i]);
        i--;
    }

    swap(act, b);

    vl pref(m + 2);

    repv(j, a) {
        int maxi = lower_bound(b.begin() + lim, b.end(), j, greater<>()) - b.begin();
        pref[maxi]++;
    }

    nrep(i, 1, m + 2) {
        pref[i] += pref[i - 1];
    }

    vvi sparse(20, vi(m));
    rep(i, m) {
        sparse[0][i] = pref[i];
    }

    nrep(j, 1, 20) {
        for (int i = 0; i + (1 << (j - 1)) < m; i++) {
            sparse[j][i] = max(sparse[j - 1][i], sparse[j - 1][i + (1 << (j - 1))]);
        }
    }

    auto query = [&](int l, int r) {
        int log = 31 - __builtin_clz(r - l + 1);
        return max(sparse[log][l], sparse[log][r - (1 << log) + 1]);
    };

    nrep(i, 1, m + 1) {
        ll ans = 0;

        for (int j = 0; j + i - 1 < m; j += i) {
            ans += query(j, j + i - 1) + 1;
        }
        
        cout << ans << " \n"[i == m];
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
